
-- KNAGSTED
NIVA = {};

function NIVA.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function NIVA:load(xmlFile)

    self.lastGrainLevel = 0;
    self.fan = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fan#index"));
    self.fanRotation = 0;
	
	self.lastGrainLevel = 0;
    self.fan1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fan1#index"));
    self.fan1Rotation = 0;
	
	self.lastGrainLevel = 0;
    self.fan2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fan2#index"));
    self.fan2Rotation = 0;
	
	self.lastGrainLevel = 0;
    self.fan3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fan3#index"));
    self.fan3Rotation = 0;

    self.val = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val#index"));
    self.valRotation = 0;

    self.val2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val2#index"));
    self.val2Rotation = 0;
	
	self.val3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val3#index"));
    self.val3Rotation = 0;
	
	self.val4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val4#index"));
    self.val4Rotation = 0;
	
	self.val5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val5#index"));
    self.val5Rotation = 0;
	
	self.val6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val6#index"));
    self.val6Rotation = 0;
	
	self.val7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val7#index"));
    self.val7Rotation = 0;
	self.val8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val8#index"));
    self.val8Rotation = 0;
	self.val9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val9#index"));
    self.val9Rotation = 0;
	self.val10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val10#index"));
    self.val10Rotation = 0;
	self.val11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val11#index"));
    self.val11Rotation = 0;
	self.val12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val12#index"));
    self.val12Rotation = 0;
	self.val13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val13#index"));
    self.val13Rotation = 0;
	self.val14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val14#index"));
    self.val14Rotation = 0;
	self.val15 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val15#index"));
    self.val15Rotation = 0;
	self.val16 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val16#index"));
    self.val16Rotation = 0;
	self.val17 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val17#index"));
    self.val17Rotation = 0;
	self.val18 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val18#index"));
    self.val18Rotation = 0;
	self.val19 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val19#index"));
    self.val19Rotation = 0;
	self.val20 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val20#index"));
    self.val20Rotation = 0;
	self.val21 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val21#index"));
    self.val21Rotation = 0;
	self.val22 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val22#index"));
    self.val22Rotation = 0;
	self.val23 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val23#index"));
    self.val23Rotation = 0;
	self.val24 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val24#index"));
    self.val24Rotation = 0;
	self.val25 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.val25#index"));
    self.val25Rotation = 0;
	

    self.grainTankAuger = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.grainTankAuger#index"));
    self.grainTankAugerRotation = 0;

    self.pipeGrainParticleSystem = {};
    self.pipeGrainParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pipeGrainParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.pipeGrainParticleSystem, "vehicle.pipeGrainParticleSystem", self.pipeGrainParticleSystemindex, false, nil, self.baseDirectory);
    
    self.pipeRapeParticleSystem = {};
    self.pipeRapeParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pipeRapeParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.pipeRapeParticleSystem, "vehicle.pipeRapeParticleSystem", self.pipeRapeParticleSystemindex, false, nil, self.baseDirectory);

    self.strawSpreaderAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.strawSpreader#count"),0);
    self.strawSpreader = {};
    for i=1, self.strawSpreaderAnz do
        local objname = string.format("vehicle.strawSpreader.strawSpreader" .. "%d",i);
        self.strawSpreader[i] = {};
        self.strawSpreader[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.strawSpreader[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
    end;

    local rotationPartNodeTanknadel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTanknadel#index"));
    if rotationPartNodeTanknadel ~= nil then
        self.rotationPartTanknadel = {};
        self.rotationPartTanknadel.node = rotationPartNodeTanknadel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#minRot"));
        self.rotationPartTanknadel.minRot = {};
        self.rotationPartTanknadel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#maxRot"));
        self.rotationPartTanknadel.maxRot = {};
        self.rotationPartTanknadel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartTanknadel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#rotTime"), 2)*1000;
        self.rotationPartTanknadel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#touchRotLimit"), 10));
    end;

    fuelwarningSoundFile = Utils.getFilename("Sound/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
	self.playedSound = false;
	self.ledriserva = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledriserva#index"));
	self.ledriservaActive = false;
	self.riserva = 40;

	local rotationPartNodeDrehzahl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#index"));
    if rotationPartNodeDrehzahl1 ~= nil then
        self.rotationPartDrehzahl1 = {};
        self.rotationPartDrehzahl1.node = rotationPartNodeDrehzahl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#minRot"));
        self.rotationPartDrehzahl1.minRot = {};
        self.rotationPartDrehzahl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#maxRot"));
        self.rotationPartDrehzahl1.maxRot = {};
        self.rotationPartDrehzahl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDrehzahl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#rotTime"), 2)*1000;
        self.rotationPartDrehzahl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#touchRotLimit"), 10));
    end;

-- voda

local rotationPartNodevoda1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.voda1#index"));
    if rotationPartNodevoda1 ~= nil then
        self.rotationPartvoda1 = {};
        self.rotationPartvoda1.node = rotationPartNodevoda1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda1#minRot"));
        self.rotationPartvoda1.minRot = {};
        self.rotationPartvoda1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda1#maxRot"));
        self.rotationPartvoda1.maxRot = {};
        self.rotationPartvoda1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartvoda1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda1#rotTime"), 2)*1000;
        self.rotationPartvoda1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda1#touchRotLimit"), 10));
    end;
local rotationPartNodevoda2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.voda2#index"));
    if rotationPartNodevoda2 ~= nil then
        self.rotationPartvoda2 = {};
        self.rotationPartvoda2.node = rotationPartNodevoda2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda2#minRot"));
        self.rotationPartvoda2.minRot = {};
        self.rotationPartvoda2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda2#maxRot"));
        self.rotationPartvoda2.maxRot = {};
        self.rotationPartvoda2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartvoda2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda2#rotTime"), 2)*1000;
        self.rotationPartvoda2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda2#touchRotLimit"), 10));
    end;
local rotationPartNodevoda3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.voda3#index"));
    if rotationPartNodevoda3 ~= nil then
        self.rotationPartvoda3 = {};
        self.rotationPartvoda3.node = rotationPartNodevoda3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda3#minRot"));
        self.rotationPartvoda3.minRot = {};
        self.rotationPartvoda3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda3#maxRot"));
        self.rotationPartvoda3.maxRot = {};
        self.rotationPartvoda3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartvoda3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda3#rotTime"), 2)*1000;
        self.rotationPartvoda3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda3#touchRotLimit"), 10));
    end;
local rotationPartNodevoda4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.voda4#index"));
    if rotationPartNodevoda4 ~= nil then
        self.rotationPartvoda4 = {};
        self.rotationPartvoda4.node = rotationPartNodevoda4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda4#minRot"));
        self.rotationPartvoda4.minRot = {};
        self.rotationPartvoda4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.voda4#maxRot"));
        self.rotationPartvoda4.maxRot = {};
        self.rotationPartvoda4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvoda4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvoda4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartvoda4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda4#rotTime"), 2)*1000;
        self.rotationPartvoda4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.voda4#touchRotLimit"), 10));
    end;

--ampermetr

local rotationPartNodeamper1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.amper1#index"));
    if rotationPartNodeamper1 ~= nil then
        self.rotationPartamper1 = {};
        self.rotationPartamper1.node = rotationPartNodeamper1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper1#minRot"));
        self.rotationPartamper1.minRot = {};
        self.rotationPartamper1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper1#maxRot"));
        self.rotationPartamper1.maxRot = {};
        self.rotationPartamper1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartamper1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper1#rotTime"), 2)*1000;
        self.rotationPartamper1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper1#touchRotLimit"), 10));
    end;
local rotationPartNodeamper2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.amper2#index"));
    if rotationPartNodeamper2 ~= nil then
        self.rotationPartamper2 = {};
        self.rotationPartamper2.node = rotationPartNodeamper2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper2#minRot"));
        self.rotationPartamper2.minRot = {};
        self.rotationPartamper2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper2#maxRot"));
        self.rotationPartamper2.maxRot = {};
        self.rotationPartamper2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartamper2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper2#rotTime"), 2)*1000;
        self.rotationPartamper2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper2#touchRotLimit"), 10));
    end;
local rotationPartNodeamper3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.amper3#index"));
    if rotationPartNodeamper3 ~= nil then
        self.rotationPartamper3 = {};
        self.rotationPartamper3.node = rotationPartNodeamper3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper3#minRot"));
        self.rotationPartamper3.minRot = {};
        self.rotationPartamper3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper3#maxRot"));
        self.rotationPartamper3.maxRot = {};
        self.rotationPartamper3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartamper3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper3#rotTime"), 2)*1000;
        self.rotationPartamper3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper3#touchRotLimit"), 10));
    end;
local rotationPartNodeamper4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.amper4#index"));
    if rotationPartNodeamper4 ~= nil then
        self.rotationPartamper4 = {};
        self.rotationPartamper4.node = rotationPartNodeamper4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper4#minRot"));
        self.rotationPartamper4.minRot = {};
        self.rotationPartamper4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper4#maxRot"));
        self.rotationPartamper4.maxRot = {};
        self.rotationPartamper4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartamper4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper4#rotTime"), 2)*1000;
        self.rotationPartamper4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper4#touchRotLimit"), 10));
    end;
local rotationPartNodeamper5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.amper5#index"));
    if rotationPartNodeamper5 ~= nil then
        self.rotationPartamper5 = {};
        self.rotationPartamper5.node = rotationPartNodeamper5;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper5#minRot"));
        self.rotationPartamper5.minRot = {};
        self.rotationPartamper5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper5#maxRot"));
        self.rotationPartamper5.maxRot = {};
        self.rotationPartamper5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartamper5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper5#rotTime"), 2)*1000;
        self.rotationPartamper5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper5#touchRotLimit"), 10));
    end;
local rotationPartNodeamper6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.amper6#index"));
    if rotationPartNodeamper6 ~= nil then
        self.rotationPartamper6 = {};
        self.rotationPartamper6.node = rotationPartNodeamper6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper6#minRot"));
        self.rotationPartamper6.minRot = {};
        self.rotationPartamper6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.amper6#maxRot"));
        self.rotationPartamper6.maxRot = {};
        self.rotationPartamper6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartamper6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartamper6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartamper6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper6#rotTime"), 2)*1000;
        self.rotationPartamper6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.amper6#touchRotLimit"), 10));
    end;

--[[windows]]------------------------------------------------------------
local rotationPartNoderightdoor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rightdoor#index"));
    if rotationPartNoderightdoor ~= nil then
        self.rotationPartrightdoor = {};
        self.rotationPartrightdoor.node = rotationPartNoderightdoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightdoor#minRot"));
        self.rotationPartrightdoor.minRot = {};
        self.rotationPartrightdoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightdoor#maxRot"));
        self.rotationPartrightdoor.maxRot = {};
        self.rotationPartrightdoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartrightdoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#rotTime"), 2)*1000;
        self.rotationPartrightdoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#touchRotLimit"), 10));
    end;
local rotationPartNodeleftdoor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.leftdoor#index"));
    if rotationPartNodeleftdoor ~= nil then
        self.rotationPartleftdoor = {};
        self.rotationPartleftdoor.node = rotationPartNodeleftdoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftdoor#minRot"));
        self.rotationPartleftdoor.minRot = {};
        self.rotationPartleftdoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftdoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftdoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftdoor#maxRot"));
        self.rotationPartleftdoor.maxRot = {};
        self.rotationPartleftdoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftdoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftdoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartleftdoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftdoor#rotTime"), 2)*1000;
        self.rotationPartleftdoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftdoor#touchRotLimit"), 10));
    end;
local rotationPartNoderightwindows = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rightwindows#index"));
    if rotationPartNoderightwindows ~= nil then
        self.rotationPartrightwindows = {};
        self.rotationPartrightwindows.node = rotationPartNoderightwindows;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightwindows#minRot"));
        self.rotationPartrightwindows.minRot = {};
        self.rotationPartrightwindows.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightwindows.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightwindows.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightwindows#maxRot"));
        self.rotationPartrightwindows.maxRot = {};
        self.rotationPartrightwindows.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightwindows.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightwindows.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartrightwindows.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightwindows#rotTime"), 2)*1000;
        self.rotationPartrightwindows.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightwindows#touchRotLimit"), 10));
    end;
local rotationPartNodeleftwindows = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.leftwindows#index"));
    if rotationPartNodeleftwindows ~= nil then
        self.rotationPartleftwindows = {};
        self.rotationPartleftwindows.node = rotationPartNodeleftwindows;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftwindows#minRot"));
        self.rotationPartleftwindows.minRot = {};
        self.rotationPartleftwindows.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftwindows.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftwindows.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftwindows#maxRot"));
        self.rotationPartleftwindows.maxRot = {};
        self.rotationPartleftwindows.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftwindows.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftwindows.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartleftwindows.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftwindows#rotTime"), 2)*1000;
        self.rotationPartleftwindows.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftwindows#touchRotLimit"), 10));
    end;

-- indikators

      self.thenlight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.thenlight#index"));
      self.thenlightActive = false;

      self.strawlight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.strawlight#index"));
      self.strawlightActive = false;

      self.pipeIslight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipeIslight#index"));
      self.pipeIslightActive = false;

      self.quadro1OFF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.quadro1OFF#index"));
      self.quadro1OFFActive = false;

      self.quadro2OFF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.quadro2OFF#index"));
      self.quadro2OFFActive = false;

      self.pipeStatelight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipeStatelight#index"));
      self.pipeStatelightActive = false;

      self.cabinlight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.cabinlight#index"));
      self.cabinlightActive = false;

      self.pipelight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipelight#index"));
      self.pipelightActive = false;

      self.workinglight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.workinglight#index"));
      self.workinglightActive = false;
	  ----< >-----	
    self.zerkala = {};
    self.zerkala[1] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.zerkala.mirror1#index"));
    ----< >-----
end;

function NIVA:delete()
Utils.deleteParticleSystem(self.pipeGrainParticleSystem); 
 Utils.deleteParticleSystem(self.pipeRapeParticleSystem);
end;

function NIVA:mouseEvent(posX, posY, isDown, isUp, button)
end;

function NIVA:keyEvent(unicode, sym, modifier, isDown)

--[[info]]------------------------------------------------------------
 if isDown and sym == Input.KEY_KP_0 then
		self.helpPanel = not self.helpPanel;
	end;
 if isDown and sym == Input.KEY_n then
		self.Kompass = not self.Kompass;
	end;

--[[windows]]------------------------------------------------------------
    if isDown and sym == Input.KEY_KP_6 then 
	self.rotationMaxrightdoor = not self.rotationMaxrightdoor;
	self.rotationMaxrightdoor1 = not self.rotationMaxrightdoor1;
    end;
    if isDown and sym == Input.KEY_KP_4 then 
	self.rotationMaxleftdoor = not self.rotationMaxleftdoor;
	self.rotationMaxleftdoor1 = not self.rotationMaxleftdoor1;
    end;
    if isDown and sym == Input.KEY_KP_5 then 
	self.rotationMaxrightwindows = not self.rotationMaxrightwindows;
	self.rotationMaxrightwindows1 = not self.rotationMaxrightwindows1;
    end;
    if isDown and sym == Input.KEY_KP_7 then 
	self.rotationMaxleftwindows = not self.rotationMaxleftwindows;
	self.rotationMaxleftwindows1 = not self.rotationMaxleftwindows1;
    end;
if isDown and sym == Input.KEY_j then
	    self.strawlightActive = not self.strawlightActive;
	end;
if isDown and sym == Input.KEY_k then 
		self.drawMirror = not self.drawMirror;
		setVisibility(self.zerkala[1], self.drawMirror);
	end;
if isDown and sym == Input.KEY_l then
	    self.pipelightActive = not self.pipelightActive;
	end;
if isDown and sym == Input.KEY_z then
	    self.workinglightActive = not self.workinglightActive;
	end;
end;

function NIVA:update(dt)

--other to motor started

if self.isMotorStarted then
self.rotationMaxvoda1 = true;
self.rotationMaxvoda2 = false;
self.rotationMaxvoda3 = true;
self.rotationMaxvoda4 = false;
self.rotationMaxamper1 = true;
self.rotationMaxamper2 = true;
self.rotationMaxamper3 = true;
self.rotationMaxamper4 = false;
self.rotationMaxamper5 = false;
self.rotationMaxamper6 = false;
            setVisibility(self.quadro1OFF, self.quadro1OFFActive);
            self.quadro1OFFActive = true;
            setVisibility(self.quadro2OFF, self.quadro2OFFActive);
            self.quadro2OFFActive = true;
         else
self.rotationMaxvoda1 = false;
self.rotationMaxvoda2 = true;
self.rotationMaxvoda3 = false;
self.rotationMaxvoda4 = true;
self.rotationMaxamper1 = false;
self.rotationMaxamper2 = false;
self.rotationMaxamper3 = false;
self.rotationMaxamper4 = true;
self.rotationMaxamper5 = true;
self.rotationMaxamper6 = true;
            setVisibility(self.quadro1OFF, self.quadro1OFFActive);
            self.quadro1OFFActive = false;
            setVisibility(self.quadro2OFF, self.quadro2OFFActive);
            self.quadro2OFFActive = false;
              end;

if self.isMotorStarted then
	   if self.motor.lastMotorRpm > 0.1 then
		self.fanRotation = self.fanRotation + 20;
		setRotation(self.fan, Utils.degToRad(self.fanRotation), 0, 0);
	   end;
	   
	   if self.motor.lastMotorRpm > 0.1 then
		self.fan1Rotation = self.fan1Rotation + 30;
		setRotation(self.fan1, Utils.degToRad(self.fan1Rotation), 0, 0);
	   end;
	   
	   if self.motor.lastMotorRpm > 0.1 then
		self.fan2Rotation = self.fan2Rotation + 30;
		setRotation(self.fan2, Utils.degToRad(self.fan2Rotation), 0, 0);
	   end;
	   
	   if self.motor.lastMotorRpm > 0.1 then
		self.fan3Rotation = self.fan3Rotation + 30;
		setRotation(self.fan3, Utils.degToRad(self.fan3Rotation), 0, 0);
	   end;
end;

	for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then
			--if self.strawEmitState or self.chopperActivated then
			if self.lastGrainLevel < self.grainTankFillLevel then 
				if self.currentGrainTankFruitType == FruitUtil.FRUITTYPE_RAPE then
					Utils.setEmittingState(self.pipeRapeParticleSystem, true);
				else
					Utils.setEmittingState(self.pipeGrainParticleSystem, true);
				end;
			else
			  	Utils.setEmittingState(self.pipeGrainParticleSystem, false);
				Utils.setEmittingState(self.pipeRapeParticleSystem, false);
			end;
			self.lastGrainLevel = self.grainTankFillLevel;
			
			self.grainTankAugerRotation = self.grainTankAugerRotation - 25;
			setRotation(self.grainTankAuger, 0, Utils.degToRad(self.grainTankAugerRotation), 0);
		    else 
			Utils.setEmittingState(self.pipeGrainParticleSystem, false);
			Utils.setEmittingState(self.pipeRapeParticleSystem, false);
		    end;
	end;

	 if self.chopperActivated then
        if self.strawSpreaderAnz > 0 then
            for i=1, self.strawSpreaderAnz do
              rotate(self.strawSpreader[i].rotNode, 0, dt*self.strawSpreader[i].speed, 0);
            end;
        end;
	end;

		if self.rotationPartTanknadel ~= nil then
			local x, y, z = getRotation(self.rotationPartTanknadel.node);
			y = ((self.rotationPartTanknadel.maxRot[2] - self.rotationPartTanknadel.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel.minRot[2];
			setRotation(self.rotationPartTanknadel.node, x, y ,z);
		end;

	if self.isEntered then
		if self.fuelFillLevel < 40 then
			self.riserva = self.riserva - dt;
			if self.playedSound == false then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.playedSound = true;
			end;
			self.ledriservaActive = true;
		else
			self.playedSound = false;
			self.ledriservaActive = false;
		    end;
		     setVisibility(self.ledriserva, self.ledriservaActive);
       end;

	local maxDrehzahl = 2000;
	if self.rotationPartDrehzahl1 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl1.node);
		y = ((self.rotationPartDrehzahl1.maxRot[2] - self.rotationPartDrehzahl1.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl1.minRot[2];
		setRotation(self.rotationPartDrehzahl1.node, x, y ,z);
	end;

-- voda

if self.rotationMaxvoda1 == true then
if self.rotationPartvoda1 ~= nil then
		   local x, y, z = getRotation(self.rotationPartvoda1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartvoda1.maxRot, self.rotationPartvoda1.minRot, 3, self.rotationPartvoda1.rotTime, dt, not self.rotationMaxvoda1);
		   setRotation(self.rotationPartvoda1.node, unpack(newRot));
       end;
   end;
if self.rotationMaxvoda2 == true then
if self.rotationPartvoda2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartvoda2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartvoda2.maxRot, self.rotationPartvoda2.minRot, 3, self.rotationPartvoda2.rotTime, dt, not self.rotationMaxvoda2);
		   setRotation(self.rotationPartvoda2.node, unpack(newRot));
       end;
   end;
if self.rotationMaxvoda3 == true then
if self.rotationPartvoda3 ~= nil then
		   local x, y, z = getRotation(self.rotationPartvoda3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartvoda3.maxRot, self.rotationPartvoda3.minRot, 3, self.rotationPartvoda3.rotTime, dt, not self.rotationMaxvoda3);
		   setRotation(self.rotationPartvoda3.node, unpack(newRot));
       end;
   end;
if self.rotationMaxvoda4 == true then
if self.rotationPartvoda4 ~= nil then
		   local x, y, z = getRotation(self.rotationPartvoda4.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartvoda4.maxRot, self.rotationPartvoda4.minRot, 3, self.rotationPartvoda4.rotTime, dt, not self.rotationMaxvoda4);
		   setRotation(self.rotationPartvoda4.node, unpack(newRot));
       end;
   end;

-- ampermetr

if self.rotationMaxamper1 == true then
if self.rotationPartamper1 ~= nil then
		   local x, y, z = getRotation(self.rotationPartamper1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartamper1.maxRot, self.rotationPartamper1.minRot, 3, self.rotationPartamper1.rotTime, dt, not self.rotationMaxamper1);
		   setRotation(self.rotationPartamper1.node, unpack(newRot));
       end;
   end;
if self.rotationMaxamper2 == true then
if self.rotationPartamper2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartamper2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartamper2.maxRot, self.rotationPartamper2.minRot, 3, self.rotationPartamper2.rotTime, dt, not self.rotationMaxamper2);
		   setRotation(self.rotationPartamper2.node, unpack(newRot));
       end;
   end;
if self.rotationMaxamper3 == true then
if self.rotationPartamper3 ~= nil then
		   local x, y, z = getRotation(self.rotationPartamper3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartamper3.maxRot, self.rotationPartamper3.minRot, 3, self.rotationPartamper3.rotTime, dt, not self.rotationMaxamper3);
		   setRotation(self.rotationPartamper3.node, unpack(newRot));
       end;
   end;
if self.rotationMaxamper4 == true then
if self.rotationPartamper4 ~= nil then
		   local x, y, z = getRotation(self.rotationPartamper4.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartamper4.maxRot, self.rotationPartamper4.minRot, 3, self.rotationPartamper4.rotTime, dt, not self.rotationMaxamper4);
		   setRotation(self.rotationPartamper4.node, unpack(newRot));
       end;
   end;
if self.rotationMaxamper5 == true then
if self.rotationPartamper5 ~= nil then
		   local x, y, z = getRotation(self.rotationPartamper5.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartamper5.maxRot, self.rotationPartamper5.minRot, 3, self.rotationPartamper5.rotTime, dt, not self.rotationMaxamper5);
		   setRotation(self.rotationPartamper5.node, unpack(newRot));
       end;
   end;
if self.rotationMaxamper6 == true then
if self.rotationPartamper6 ~= nil then
		   local x, y, z = getRotation(self.rotationPartamper6.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartamper6.maxRot, self.rotationPartamper6.minRot, 3, self.rotationPartamper6.rotTime, dt, not self.rotationMaxamper6);
		   setRotation(self.rotationPartamper6.node, unpack(newRot));
       end;
   end;



-- indikators

if self.isThreshing then
	   if self.motor.lastMotorRpm > 0.1 then
		self.valRotation = self.valRotation + 20;
		setRotation(self.val, Utils.degToRad(self.valRotation), 0, 0);
		self.val2Rotation = self.val2Rotation + 20;
		setRotation(self.val2, Utils.degToRad(self.val2Rotation), 0, 0);
		self.val3Rotation = self.val3Rotation + 20;
		setRotation(self.val3, Utils.degToRad(self.val3Rotation), 0, 0);
		self.val4Rotation = self.val4Rotation + 20;
		setRotation(self.val4, Utils.degToRad(self.val4Rotation), 0, 0);
		self.val5Rotation = self.val5Rotation + 20;
		setRotation(self.val5, Utils.degToRad(self.val5Rotation), 0, 0);
		self.val6Rotation = self.val6Rotation - 20;
		setRotation(self.val6, Utils.degToRad(self.val6Rotation), 0, 0);
		self.val7Rotation = self.val7Rotation - 20;
		setRotation(self.val7, Utils.degToRad(self.val7Rotation), 0, 0);
		self.val8Rotation = self.val8Rotation + 20;
		setRotation(self.val8, Utils.degToRad(self.val8Rotation), 0, 0);
		self.val9Rotation = self.val9Rotation + 20;
		setRotation(self.val9, Utils.degToRad(self.valRotation), 0, 0);
		self.val10Rotation = self.val10Rotation + 20;
		setRotation(self.val10, Utils.degToRad(self.val10Rotation), 0, 0);
		self.val11Rotation = self.val11Rotation - 20;
		setRotation(self.val11, Utils.degToRad(self.val11Rotation), 0, 0);
		self.val12Rotation = self.val12Rotation + 20;
		setRotation(self.val12, Utils.degToRad(self.val12Rotation), 0, 0);
		self.val13Rotation = self.val13Rotation - 20;
		setRotation(self.val13, Utils.degToRad(self.val13Rotation), 0, 0);
		self.val14Rotation = self.val14Rotation + 20;
		setRotation(self.val14, Utils.degToRad(self.val14Rotation), 0, 0);
		self.val15Rotation = self.val15Rotation + 20;
		setRotation(self.val15, Utils.degToRad(self.val15Rotation), 0, 0);
		self.val16Rotation = self.val16Rotation + 20;
		setRotation(self.val16, Utils.degToRad(self.val16Rotation), 0, 0);
		self.val17Rotation = self.val17Rotation - 20;
		setRotation(self.val17, Utils.degToRad(self.val17Rotation), 0, 0);
		self.val18Rotation = self.val18Rotation - 20;
		setRotation(self.val18, Utils.degToRad(self.val18Rotation), 0, 0);
		self.val19Rotation = self.val19Rotation + 20;
		setRotation(self.val19, Utils.degToRad(self.val19Rotation), 0, 0);
		self.val20Rotation = self.val20Rotation + 20;
		setRotation(self.val20, Utils.degToRad(self.val20Rotation), 0, 0);
		self.val21Rotation = self.val21Rotation - 20;
		setRotation(self.val21, Utils.degToRad(self.val21Rotation), 0, 0);
		self.val22Rotation = self.val22Rotation + 20;
		setRotation(self.val22, Utils.degToRad(self.val22Rotation), 0, 0);
		self.val23Rotation = self.val23Rotation + 20;
		setRotation(self.val23, Utils.degToRad(self.val23Rotation), 0, 0);
		self.val24Rotation = self.val24Rotation + 20;
		setRotation(self.val24, Utils.degToRad(self.val24Rotation), 0, 0);
		self.val25Rotation = self.val25Rotation + 20;
		setRotation(self.val25, Utils.degToRad(self.val25Rotation), 0, 0);
       end;
	setVisibility(self.thenlight, self.thenlightActive);
	self.thenlightActive = true;
         else
             setVisibility(self.thenlight, self.thenlightActive);
             self.thenlightActive = false;
     end;
if self.isEntered then
		setVisibility(self.strawlight, self.strawlightActive);
	end;
 if self.pipeIsUnloading then
	setVisibility(self.pipeIslight, self.pipeIslightActive);
	self.pipeIslightActive = true;
         else
             setVisibility(self.pipeIslight, self.pipeIslightActive);
             self.pipeIslightActive = false;
     end;
 if self.targetPipeState ~= 1 then
	setVisibility(self.pipeStatelight, self.pipeStatelightActive);
	self.pipeStatelightActive = true;
         else
             setVisibility(self.pipeStatelight, self.pipeStatelightActive);
             self.pipeStatelightActive = false;
     end;
if self.isEntered then
		setVisibility(self.cabinlight, self.cabinlightActive);
	end;
if self.isEntered then
		setVisibility(self.pipelight, self.pipelightActive);
	end;
if self.isEntered then
		setVisibility(self.workinglight, self.workinglightActive);
	end;

	if self.handbrake then
		self.motor.maxRpm[1] = 0;
        self.motor.maxRpm[2] = 0;
        self.motor.maxRpm[3] = 0;
		
	 end;  
	
	
	if not self.handbrake then
	    self.motor.maxRpm[1] = 860;
        self.motor.maxRpm[2] = 960;
        self.motor.maxRpm[3] = 2000;
	end;	
 end;

function NIVA:draw()

--[[info]]------------------------------------------------------------
 if self.isEntered then
	
end;
		local prozent = self.grainTankFillLevel/self.grainTankCapacity*100;
		if prozent > 0 then
		renderText(0.75, 0.74, 0.02,""..string.format("Grain: %.0f (%d%%)", self.grainTankFillLevel, prozent).."");
		end;

	
end;

